package body Video.Pixels.Generic_Renderers.Color is

	procedure Clear (
		Target : in out Color_Renderer;
		Color  : in     Colors.Color)
	is
	begin
		Target.Clear (From_Color (Color));
	end Clear;

	procedure Write_Pixel (
		Target : in out Color_Renderer;
		A      : in     Integer_Geometry.Point;
		Color  : in     Colors.Color)
	is
	begin
		Target.Write_Pixel (A, From_Color (Color));
	end Write_Pixel;

	procedure Fill_Rectangle (
		Target : in out Color_Renderer;
		Bounds : in     Integer_Geometry.Box;
		Color  : in     Colors.Color)
	is
	begin
		Target.Fill_Rectangle (Bounds, From_Color (Color));
	end Fill_Rectangle;

	procedure Line (
		Target : in out Color_Renderer;
		A, B   : in     Integer_Geometry.Point;
		Color  : in     Colors.Color)
	is
	begin
		Target.Line (A, B, From_Color (Color));
	end Line;

	procedure Circle (
		Target : in out Color_Renderer;
		Center : in     Integer_Geometry.Point;
		Radius : in     Natural;
		Color  : in     Colors.Color)
	is
	begin
		Target.Circle (Center, Radius, From_Color (Color));
	end Circle;

	procedure Ellipse (
		Target : in out Color_Renderer;
		Bounds : in     Integer_Geometry.Box;
		Color  : in     Colors.Color)
	is
	begin
		Target.Ellipse (Bounds, From_Color (Color));
	end Ellipse;

end Video.Pixels.Generic_Renderers.Color;
