with Video.Colors;
with Video.Renderables.Color;
generic
	with function From_Color (Color : Colors.Color) return Pixel is <>;
package Video.Pixels.Generic_Renderers.Color is

	type Color_Renderer is limited new Renderer and Renderables.Color.Renderable with null record;

	procedure Clear (
		Target : in out Color_Renderer;
		Color  : in     Colors.Color);

	procedure Write_Pixel (
		Target : in out Color_Renderer;
		A      : in     Integer_Geometry.Point;
		Color  : in     Colors.Color) with Inline;

	procedure Fill_Rectangle (
		Target : in out Color_Renderer;
		Bounds : in     Integer_Geometry.Box;
		Color  : in     Colors.Color);

	procedure Line (
		Target : in out Color_Renderer;
		A, B   : in     Integer_Geometry.Point;
		Color  : in     Colors.Color);

	procedure Circle (
		Target : in out Color_Renderer;
		Center : in     Integer_Geometry.Point;
		Radius : in     Natural;
		Color  : in     Colors.Color);

	procedure Ellipse (
		Target : in out Color_Renderer;
		Bounds : in     Integer_Geometry.Box;
		Color  : in     Colors.Color);

end Video.Pixels.Generic_Renderers.Color;
