with Video.Pixels.Generic_Blits;

package body Video.Pixels.Generic_Renderers is

	package Blits is new Generic_Blits (
		Pixel => Pixel,
		Pixel_Array => Pixel_Array);

	procedure Clear (
		Target : in out Renderer;
		Paint  : in     Pixel)
	is
	begin
		for Y in Target.Target'Range (1) loop
			for X in Target.Target'Range (2) loop
				Target.Target (Y, X) := Paint;
			end loop;
		end loop;
	end Clear;

	procedure Write_Pixel (
		Target : in out Renderer;
		A      : in     Integer_Geometry.Point;
		Paint  : in     Pixel)
	is
	begin
		Target.Target (A.Y, A.X) := Paint;
	end Write_Pixel;

	procedure Fill_Rectangle (
		Target : in out Renderer;
		Bounds : in     Integer_Geometry.Box;
		Paint  : in     Pixel)
	is
	begin
		for Y in Bounds.Y.First .. Bounds.Y.Last - 1 loop
			for X in Bounds.X.First .. Bounds.X.Last - 1 loop
				Target.Target (Y, X) := Paint;
			end loop;
		end loop;
	end Fill_Rectangle;

	procedure Line (
		Target : in out Renderer;
		A, B   : in     Integer_Geometry.Point;
		Paint  : in     Pixel)
	is
	begin
		Blits.Line (Paint, Target.Target.all, A, B);
	end Line;

	procedure Circle (
		Target : in out Renderer;
		Center : in     Integer_Geometry.Point;
		Radius : in     Natural;
		Paint  : in     Pixel)
	is
	begin
		Blits.Circle (Paint, Target.Target.all, Center, Radius);
	end Circle;

	procedure Ellipse (
		Target : in out Renderer;
		Bounds : in     Integer_Geometry.Box;
		Paint  : in     Pixel)
	is
	begin
		Blits.Ellipse (Paint, Target.Target.all, Bounds);
	end Ellipse;

end Video.Pixels.Generic_Renderers;
