with Ada.Text_IO, Ada.Integer_Text_IO;
use  Ada.Text_IO, Ada.Integer_Text_IO;
with Interfaces.C;
with SDL.Video.Windows.Makers;
with SDL.Video.Renderers.Makers;
with SDL.Events.Events;
with SDL.Images.IO;
with Video.Colors;
with Video.Integer_Geometry;
with Video.SDL2.Renderers;
with Video.SDL2.Textures;
with Example_Scene;

procedure Example_SDL_Render is
	Screen_Width  : constant := 640;
	Screen_Height : constant := 480;
	Wnd           : aliased SDL.Video.Windows.Window;
	Ev            : SDL.Events.Events.Events;
	use type SDL.Events.Event_Types;
begin
	if not SDL.Initialise (Flags => SDL.Enable_Screen) then
		raise Program_Error;
	end if;

	SDL.Video.Windows.Makers.Create (
		Win      => Wnd,
		Title    => "Hello World",
		Position => SDL.Natural_Coordinates'(
			SDL.Video.Windows.Centered_Window_Position,
			SDL.Video.Windows.Centered_Window_Position),
		Size     => SDL.Positive_Sizes'(Screen_Width, Screen_Height),
		Flags    => 0);

	declare
		Rend          : Video.SDL2.Renderers.SDL_Renderer;
		Img           : Video.SDL2.Textures.SDL_Texture;
	begin

		SDL.Video.Renderers.Makers.Create (Rend.Data, Wnd);

		Example_Scene (Rend);

		-- SDL.Images.IO.Create (Img.Data, Rend.Data, "build/share/video/visi.bmp");
		-- Rend.Paste ((10, 10), Img);
	end;

	Wait : loop
		while SDL.Events.Events.Poll (Ev) loop
			exit Wait when Ev.Common.Event_Type = SDL.Events.Quit;
		end loop;
	end loop Wait;

	Wnd.Finalize;

	SDL.Finalise;
end Example_SDL_Render;
