with Ada.Text_IO, Ada.Integer_Text_IO;
use  Ada.Text_IO, Ada.Integer_Text_IO;
with Interfaces.C;
with SDL.Video.Windows.Makers;
with SDL.Video.Surfaces;
with SDL.Events.Events;
with SDL.Images.IO;
with SDL.TTFs.Makers;
with Video.Colors;
with Video.Integer_Geometry;
with Video.SDL2.Surfaces;
with Example_Scene;
with Video.SDL2.Surfaces.TTFs;
with Video.SDL2.Colors;

procedure Example_SDL_Surface is
	Screen_Width  : constant := 640;
	Screen_Height : constant := 480;
	Wnd           : aliased SDL.Video.Windows.Window;
	Ev            : SDL.Events.Events.Events;
	use type SDL.Events.Event_Types;
begin
	if not SDL.Initialise (Flags => SDL.Enable_Screen) then
		raise Program_Error;
	end if;

	SDL.Video.Windows.Makers.Create (
		Win      => Wnd,
		Title    => "Hello World",
		Position => SDL.Natural_Coordinates'(
			SDL.Video.Windows.Centered_Window_Position,
			SDL.Video.Windows.Centered_Window_Position),
		Size     => SDL.Positive_Sizes'(Screen_Width, Screen_Height),
		Flags    => 0);

	declare
		Surf          : aliased Video.SDL2.Surfaces.Window_Surface (Wnd'Access);
		BBox          : Video.Integer_Geometry.Box;
		Img           : Video.SDL2.Surfaces.SDL_Surface;
		Wrt           : Video.SDL2.Surfaces.TTFs.TTF_on_Surface (Surf'Access);
	begin

		BBox := Surf.Bounding_Box;
		Put (BBox.X.First); Put (" .. "); Put (BBox.X.Last); Put (" x "); Put (BBox.Y.First); Put (" .. "); Put (BBox.Y.Last); New_Line;
		--Put ("Pitch:           "); Put (Integer (Surf.To_SDL.pitch)); New_Line;
		--Put ("Bits per pixel:  "); Put (Integer (Surf.To_SDL.format.Bits_Per_Pixel)); New_Line;
		--Put ("Bytes per pixel: "); Put (Integer (Surf.To_SDL.format.Bytes_Per_Pixel)); New_Line;

		Example_Scene (Surf);

		SDL.Images.IO.Create (Img.Data, "build/share/video/visi.bmp");
		Surf.Paste ((10, 10), Img);

		if not SDL.TTFs.Initialise then
			raise Program_Error;
		end if;
		SDL.TTFs.Makers.Create (Wrt.Typeface,
			"/usr/share/fonts/dejavu/DejaVuSans.ttf",
			16);
		Wrt.Foreground := Video.SDL2.Colors.To_SDL (Video.Colors.RGB_8 (255, 255, 255));
		Wrt.Write ((100, 150), "TTF Renderer?");
		SDL.TTFs.Finalise;
	end;

	Wait : loop
		while SDL.Events.Events.Poll (Ev) loop
			exit Wait when Ev.Common.Event_Type = SDL.Events.Quit;
		end loop;
	end loop Wait;

	Wnd.Finalize;

	SDL.Finalise;
end Example_SDL_Surface;
