with SDL.Video.Rectangles;
use type SDL.Coordinate;
use type SDL.Natural_Dimension;

with Video.Integer_Geometry;
use  Video.Integer_Geometry;

package Video.SDL2.Rectangles is

	function To_Interval (
		X : SDL.Coordinate;
		W : SDL.Natural_Dimension)
		return Interval
	is (First => Coordinate (X), Last => Coordinate (X + W));

	function From_SDL (P : SDL.Video.Rectangles.Point) return Point
	is (X => Coordinate (P.X), Y => Coordinate (P.Y));

	function To_SDL (P : Point) return SDL.Video.Rectangles.Point
	is (X => SDL.Coordinate (P.X), Y => SDL.Coordinate (P.Y));

	function From_SDL (R : SDL.Sizes) return Box
	is (X => (0, Coordinate (R.Width)), Y => (0, Coordinate (R.Height)));

	function From_SDL (R : SDL.Video.Rectangles.Rectangle) return Box
	is (X => To_Interval (R.X, R.Width), Y => To_Interval (R.Y, R.Height));

	function To_SDL (B : Box) return SDL.Video.Rectangles.Rectangle is (
		X      => SDL.Coordinate (B.X.First),
		Y      => SDL.Coordinate (B.Y.First),
		Width  => SDL.Natural_Dimension (Length (B.X)),
		Height => SDL.Natural_Dimension (Length (B.Y)));

	function To_SDL_Line_Segment (A, B : Point) return SDL.Video.Rectangles.Line_Segment is (
		Start  => To_SDL (A),
		Finish => To_SDL (B));
end Video.SDL2.Rectangles;
